


function Gear4MooOnLoad(self)
    print ("Loading Gear4Moo...");
    self:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
end

function Gear4MooOnEvent(self, event, ...)
    if (event == "PLAYER_EQUIPMENT_CHANGED") then
        gear4Player();
    end
end
-- Thanks to Neil040, the maintainer of GearBuddy, as I used his plugin as the basis for mine

-- Link to itemtype info http://www.wowwiki.com/ItemType
-- Link to getting player class - http://www.wowwiki.com/API_UnitClass
-- Find out how to overlay Graphics vs Txt, otherwise potentially use text check/cross or OK/BAD in green/red


-- Need to get the player class and spec
-- Stage 1:Need to determine item type, ie cloth, leather, etc, and check if appropriate - DONE
-- Stage 2:Need to check CLASS appropriate, ie intellect on DK
-- Stage 3:Need to check SPEC appropriate , ie DPS spec with Dodge
-- Stage 4:Loop through inventory items and mark with tick/cross as to whether spec appropriate
-- Stage 5:Look through inventory items and indicate potential upgrades based on ilvl (nothing more complicted)
-- Stage 6:After level 30, mark grey/white items as bad
-- Stage 7:Need to understand armor graduation, ie cloth->leather->mail->plate based on player level

-- TODO : Disable the Plate/Mail/Leather check if < 40 OR add logic for the stepdown
-- TODO : Set ilvl thresholds at 30/40/50/60/70/80/85/90 to warn if item is just too low to be useful
-- TODO : Inventory Scanning to identify items worth equipping vs items worth selling (worse than current)
-- TODO : Give thought to tanking , in terms of dodge/parry
-- TODO : Refactor out last remenents of GearBuddy Artifacts
-- TODO : Look into hasharray based approach, ie populate a hash with acceptable commbinations and then evaluate the keys
-- TODO : Move Frequently used stuff into functions

function checkItems4Player()
    local itemStatusBySlot={"","","","","","","","","","","","","","","","","",""};

    --print ("Player is a Level " .. plevel.." " ..class.." in spec ".. specname .. " having role " .. role);

    for invSlot=1,17 do
        local itemID = GetInventoryItemLink("player",invSlot);

        if itemID then
            local itemName,_,itemRarity,itemLevel,_,itemType,itemSubtype,_,_,_,_ = GetItemInfo(itemID);
            local stats = GetItemStats(itemID);
            local hasStrength=(stats["ITEM_MOD_STRENGTH_SHORT"] or 0 );
            local hasAgility=(stats["ITEM_MOD_AGILITY_SHORT"] or 0 );
            itemStatusBySlot[invSlot]=checkItemLevel(itemLevel,itemRarity);
            if plevel > 25 and itemRarity < 2 then
                itemStatusBySlot[invSlot] = "X";
            end

            --print (" - Found " .. itemName .. " of type " .. itemType .. itemSubtype .. " with ilvl " .. itemLevel .. " in slot " .. invSlot);
            if classid == 6 or classid == 1 or classid == 2 then        -- DeathKnight / Warrior / Paladin
                if invSlot ~= 15 then
                    if plevel > 45 then
                        if itemType == "Armor" and itemSubtype ~= "Plate" and itemSubtype ~= "Miscellaneous" then
                            itemStatusBySlot[invSlot] = "X";
                        end
                    else
                        if itemType == "Armor" and itemSubtype ~= "Plate" and itemSubtype ~= "Mail" and itemSubtype ~= "Miscellaneous" then
                            itemStatusBySlot[invSlot] = "X";
                        end
                    end
                end
                if role ~= "HEALER" then
                    if (stats["ITEM_MOD_INTELLECT_SHORT"] or 0 ) > 0 then
                        itemStatusBySlot[invSlot] = "X";
                    elseif (stats["ITEM_MOD_SPIRIT_SHORT"] or 0) >0 then
                        itemStatusBySlot[invSlot] = "X";
                    end
                else
                    if (stats["ITEM_MOD_STRENGTH_SHORT"] or 0 ) > 0 then
                        itemStatusBySlot[invSlot] = "X";
                    end
                end
                if (stats["ITEM_MOD_AGILITY_SHORT"] or 0) > 0 and classid ~=6 then    -- Fix for Death Knights and Agility
                    itemStatusBySlot[invSlot] = "X";
                end

            elseif classid == 3 or classid == 7 then   -- Hunter / Shamen
                if invSlot ~= 15 then
                    if plevel > 45 then
                        if itemType == "Armor" and itemSubtype ~= "Mail" and itemSubtype ~= "Miscellaneous" then
                            itemStatusBySlot[invSlot] = "X";
                        end
                    else
                        if itemType == "Armor" and itemSubtype ~= "Mail" and itemSubtype ~= "Leather" and itemSubtype ~= "Miscellaneous" then
                            itemStatusBySlot[invSlot] = "X";
                        end
                    end
                end
                if role ~= "HEALER" then
                    if spec == "Elemental" then -- Special Check for Elemental Shamen
                        if (stats["ITEM_MOD_AGILITY_SHORT"] or 0) > 0 then
                            itemStatusBySlot[invSlot] = "X";
                        end
                    else
                        if (stats["ITEM_MOD_INTELLECT_SHORT"] or 0) > 0 then
                            itemStatusBySlot[invSlot] = "X";
                        elseif (stats["ITEM_MOD_SPIRIT_SHORT"] or 0) >0 then
                            itemStatusBySlot[invSlot] = "X";
                        end
                    end
                else
                    if (stats["ITEM_MOD_AGILITY_SHORT"] or 0) > 0 then
                        itemStatusBySlot[invSlot] = "X";
                    end
                end
                if (stats["ITEM_MOD_STRENGTH_SHORT"] or 0) > 0 then
                    itemStatusBySlot[invSlot] = "X";
                end
            elseif classid == 4 or classid == 10 or classid == 11 then  -- Rogue, Druid, Monk
                if invSlot ~= 15 then
                    if plevel > 30 then
                        if itemType == "Armor" and itemSubtype ~= "Leather" and itemSubtype ~= "Miscellaneous" then
                            itemStatusBySlot[invSlot] = "X";
                        end
                    end
                end
                if role ~= "HEALER" then
                    if spec == "Balance" then -- Special Check for Balance Druids
                        if (stats["ITEM_MOD_AGILITY_SHORT"] or 0) > 0 then
                            itemStatusBySlot[invSlot] = "X";
                        end
                    else
                        if (stats["ITEM_MOD_INTELLECT_SHORT"] or 0) > 0 then
                            itemStatusBySlot[invSlot] = "X";
                        elseif (stats["ITEM_MOD_SPIRIT_SHORT"] or 0) >0 then
                            itemStatusBySlot[invSlot] = "X";
                        end
                    end
                else
                    if (stats["ITEM_MOD_AGILITY_SHORT"] or 0) > 0 then
                        itemStatusBySlot[invSlot] = "X";
                    end
                end
                if (stats["ITEM_MOD_STRENGTH_SHORT"] or 0) > 0 then
                    itemStatusBySlot[invSlot] = "X";
                end
            else -- we are a clothy, ie Mage/Warlock/Priest
                -- we dont get strength/agi on cloth
                -- we dont get dodge/parry on cloth
            end
        else
            itemStatusBySlot[invSlot] = "";
        end
    end
    return itemStatusBySlot;
end

function slotColor(status)
    if status == "X" then
        return 1;
    else
        return 0;
    end
end

function checkItemQuality (itemQuality)
    if plevel > 25 and itemQuality < 2 then
        return "X";
    else
        return "";
    end
end

function checkArmorType (itemType,itemSubType)
    if plevel > 30 then

    elseif plevel > 45 then

    end
    return "";
end

function checkItemLevel (itemLevel,itemRarity)

    if itemRarity == 7 then
        return "";
    end

    if plevel >= 60 and itemLevel < 30 then
        return "X";
    elseif plevel >= 70 and itemLevel < 92 then
        return "X";
    elseif plevel >= 80 and itemLevel < 180 then  -- 164
        return "X";
    elseif plevel >= 85 and itemLevel < 284 then
        return "X";
    elseif plevel >=90 and itemLevel < 364 then
        return "X";
    elseif plevel >=100 and itemLevel < 496 then
        return "X";
    else
        return "";
    end
end


function gear4Player()
    local itemStatusBySlot={"","","","","","","","","","","","","","","","","",""};
    plevel = UnitLevel("player");
    class,_,classid = UnitClass("player");
    local specid=GetSpecialization();
    spec = specid and select(2, GetSpecializationInfo(specid)) or "None"
    --Our frame is a child of the paperdoll frame and each slot now has an overlay text box to hold the status

    if plevel > 10 and specid ~= nil then
        _, _, _, _, _, role = GetSpecializationInfo(GetSpecialization());
        itemStatusBySlot = checkItems4Player();
    end

    HeadSlotMooText:SetFormattedText(itemStatusBySlot[1]);
    HeadSlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[1]));
    NeckSlotMooText:SetFormattedText(itemStatusBySlot[2]);
    NeckSlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[2]));
    ShoulderSlotMooText:SetFormattedText(itemStatusBySlot[3]);
    ShoulderSlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[3]));
    BackSlotMooText:SetFormattedText(itemStatusBySlot[15]);
    BackSlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[15]));
    ChestSlotMooText:SetFormattedText(itemStatusBySlot[5]);
    ChestSlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[5]));
    WristSlotMooText:SetFormattedText(itemStatusBySlot[9]);
    WristSlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[9]));
    HandsSlotMooText:SetFormattedText(itemStatusBySlot[10]);
    HandsSlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[10]));
    WaistSlotMooText:SetFormattedText(itemStatusBySlot[6]);
    WaistSlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[6]));
    LegsSlotMooText:SetFormattedText(itemStatusBySlot[7]);
    LegsSlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[7]));
    FeetSlotMooText:SetFormattedText(itemStatusBySlot[8]);
    FeetSlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[8]));
    Finger0SlotMooText:SetFormattedText(itemStatusBySlot[11]);
    Finger0SlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[11]));
    Finger1SlotMooText:SetFormattedText(itemStatusBySlot[12]);
    Finger1SlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[12]));
    Trinket0SlotMooText:SetFormattedText(itemStatusBySlot[13]);
    Trinket0SlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[13]));
    Trinket1SlotMooText:SetFormattedText(itemStatusBySlot[14]);
    Trinket1SlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[14]));
    MainHandSlotMooText:SetFormattedText(itemStatusBySlot[16]);
    MainHandSlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[16]));
    SecondaryHandSlotMooText:SetFormattedText(itemStatusBySlot[17]);
    SecondaryHandSlotMooText:SetTextColor(1,0,0,slotColor(itemStatusBySlot[17]));
end
-- CLASS INDEXES
-- None = 0
-- Warrior = 1
-- Paladin = 2
-- Hunter = 3
-- Rogue = 4
-- Priest = 5
-- DeathKnight = 6
-- Shaman = 7
-- Mage = 8
-- Warlock = 9
-- Monk = 10
-- Druid = 11

-- ITEM RARITY
--0 Poor ff9d9d9d
--1 Common ffffffff
--2 Uncommon ff1eff00
--3 Rare ff0070dd
--4 Epic ffa335ee
--5 Legendary ffff8000
--6 Artifact ffe6cc80
--7 Heirloom ffe6cc80